<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>JavaScript HW 5</title>
</head>
<body>
<script>
    function nameChecker (namePart) {
        while (!isNaN(namePart) || namePart === "null") {
            namePart = prompt("Please, retry with a correct data!", namePart);
        }
        return (namePart);
    }

    function birthDateChecker (date) {
        while (date.substr(-5,1) !== "." || date.substr(-4,4) === "YYYY" || date.split(".")[0] > 31 || date.split(".")[0] < 1 || date.split(".")[1] > 12 || date.split(".")[1] < 1 || date.split(".")[2] > 2020 || date.split(".")[2] < 1920) {
            date = prompt("Please, use the correct format!", "DD.MM.YYYY");
        }
        return (date);
    }

    function createNewUser() {
        let userFirstName = prompt("Please, enter your first name below:", "");
        let firstName = nameChecker(userFirstName);

        let userLastName = prompt("Please, enter your last name below:", "");
        let lastName = nameChecker(userLastName);

        let userBirthDate = prompt("Please, enter the date of your birthday", "DD.MM.YYYY");
        let birthDate = birthDateChecker(userBirthDate);

        return newUser = {
            firstName,
            lastName,
            getBirthDay: function() {
                let date = birthDate.split(".")[1] + "." + birthDate.split(".")[0] + "." + birthDate.split(".")[2];
                return new Date(date);
            },

            getAge: function () {
                let accurateAge = ((new Date().getTime() - this.getBirthDay().getTime()) / (3.156e+10));
                return accurateAge.toString().substr(0,2);
            },

            getLogin: function() {
                return this.firstName.toLowerCase()[0] + this.lastName.toLowerCase();
            },

            getPassword: function () {
                return this.firstName[0].toUpperCase() + this.lastName.toLowerCase() + this.getBirthDay().getFullYear();
            },
        }
    }


    console.log("the new user's profile is -", createNewUser());
    console.log("the new user's birthday is -", newUser.getBirthDay());
    console.log("the new user's actual age is -", newUser.getAge());
    console.log("the new user's login is -", newUser.getLogin());
    console.log("the new user's password is -", newUser.getPassword());

</script>
</body>
</html>

<!--Экранирование - это инструмент, который дает нам возможность "обратить внимание" интерпритатора на-->
<!--спецсимволы в коде. Используется для поиска спецсимволов (напр., чтобы найти в коде спецсимвол $,-->
<!--нужно в команде .match() добавить перед ним обратный слэш "\$"; в результате: .match(/\$/)).-->

<!--Также экранирование можно использовать во время написания инструкций, которые содержат больше чем-->
<!--одну пару одинаковых кавычек.-->
<!--К примеру, команда alert("Вы используете слишком много однотипных кавычек, запутывая "интерпритатор"!");-->
<!--не будет адекватно обработана браузером. Решить проблему можно, чередуя для отдельных выражений-->
<!--или словосочетаний разные типы кавычек ("" и ''), или использовать однотипные кавычки и сочетать-->
<!--их с экранированием, выделяя таким образом те пары спецсимволов, которые находятся внутри-->
<!--выражения, напр.: alert("Вы используете слишком много однотипных кавычек, запутывая \"интерпритатор\"!");-->